include psav1.mac
.model tiny
.data
eskisurucu      db ?
bmstr   db'     Partition table and Boot sector scaning..',0
kutukno dw ?
surucu  db ?
surucustr db ?
	db':\PartBoot.Psa',0
part    db 512 dup(?)
boot    db 512 dup(?)
tampon1 db 512 dup(?)
tampon2 db 512 dup(?) 

msj2    db'PARTITION TABLE ve BOOT sektr normal..',0  
msj3    db'PARTITION/BOOT sektrlerinin yedekleri PARTBOOT.PSA dosyasna alnd.',0 
msj7    db'PARTITION/BOOT sektrlerindeki degisiklik dzeltildi.',0

duz1    db'PARTITION table ve BOOT sektrndeki bilgiler ile',0
duz2    db'PARTBOOT.PSA dosyasndaki bilgiler ayni degil...',0 
backup1 db'B',0
backup2 db'ackup  (PARTBOOT.PSA dosyasna tekrar yedek al)',0   
rest1   db'R'
rest2   db'estore (Ortaya kan bu deiiklii dzelt)',0
deva1   db'D'
deva2   db'evam   (Bunun farkndaym.Bir ey yapma)',0
reset1  db'T',0
reset2  db'Reset   (Bilgisayar resetle) ',0 

men1s1  db'  PARTITION TABLE ve BOOT SECTOR bilgilerinin',0
men1s2  db'yedeklendigi PARTBOOT.PSA dosyas bulunamad.',0
men1s3  db'Bu sektrlerin yedeklenmesini istermisiniz ?',0  
evetE   db'E',0
evetD   db'vet',0
hayirH  db'H',0
hayirD  db'ayir',0
diskop1 db'  Alnan bu yedek dosyasndan A: srcsndeki',0 
diskop2 db'  disketede bir  kopya alnacakm ?',0

hata21   db '        PARTBOOT.PSA dosyas okunamyor.',0
hata22   db '        PARTBOOT.PSA dosyas alamyor.',0
hata24   db '      PARTBOOT.PSA dosyasna eksik yazld.',0
hata23   db '       PARTBOOT.PSA dosyasna yazlamyor.',0  
hata27   db '          PARTITION sektor okunamyor.',0 
hata28   db '           BOOT sector okunamyor.',0
hata25   db '           BOOT sektrne yazlamyor.',0 
hata26   db '         PARTITION sectrne yazlamyor.',0 
hata20   db '               Disk(et)te hata var.',0

.code
extrn logobas:near,searchdrive:byte,savescreen:near,restorescreen:near
extrn cursor:near,set_old_int24h:near,yanlislik:near 
extrn ekryaz:near,cerceve:near,sesver:near,searchdrive:byte  
extrn bulunanboot:near,arananboot:near
extrn stonedduz:byte,bootbsayi:byte,stonedmsj:byte,nointduz:byte
extrn nointmsj:byte,michduz:byte,michmsj:byte,cansumsj:byte,formdduz:byte
extrn formmsj:byte,acadbootduz:byte,anticadbootmsj:byte
extrn menu1str:byte,secimstr:byte,aktift:byte,aktifd:byte,aktifc:byte
extrn aktifb:byte,temizbsayi:byte,temizboot:near
public bootkoru,antiboot

bootkoru proc   near
	mov     ah,0fh
	int     10h
	mov     ah,0
	int     10h
	call    cursor
	mov     ah,19h
	int     21h
	mov     eskisurucu,al
	call    logobas
	mov     al,searchdrive
	cmp     al,'Z'
	jnz     suruvar
	mov     ah,19h
	int     21h
	and     al,00000011b
	cmp     al,3
	jb      extno
	mov     al,2
extno:
	mov     searchdrive,al
suruvar:
	mov     surucu,al
	cmp     surucu,2
	jb      disket
	add     surucu,126
disket:
	add     al,65
	mov     surucustr,al
	call    part_boot_oku        
	mov     ax,3d00h       
	lea     dx,surucustr        
	int     21h          
	jb      dosya_yarat
	call    karsilastirma     
	jmp     cikis
dosya_yarat:
	call    kont_dosya_yarat
karsilastirma:
	mov     bx,ax       
	mov     ah,3fh
	mov     cx,1024
	lea     dx,tampon1
	int     21h
	jnc     dosyadan_okundu                
	lea     dx,hata21        
	call    yanlislik
	jmp     cikis
dosyadan_okundu:
	cmp     ax,cx
	jz      tamoku
	jmp     silicik
tamoku:        
	lea     di,tampon1
	lea     si,part
	mov     cx,1024
	rep     cmpsb
	jnz     hatabulundu
	print   7,3,14,msj2
	jmp     cikis
hatabulundu:
	call     sesver
	call     savescreen
	window   8,15,50,7,4fh,1
	print   9,16,4fh,duz1
	print   10,16,4fh,duz2
	print   12,17,74h,rest1
	print   12,18,4fh,rest2
	print   13,17,74h,backup1
	print   13,18,4fh,backup2
	print   14,17,74h,deva1
	print   14,18,4fh,deva2
	print   15,17,4fh,reset2
	print   15,21,74h,reset1
anlamadim:
	mov     ax,0c07h
	int     21h
	and     al,11011111b
	cmp     al,'R'
	jz      restet
	cmp     al,'B'
	jz      yenibac
	cmp     al,'D'
	jz      farkinda
	cmp     al,'T'
	jz      donboot
	jmp     anlamadim
farkinda:        
	call    restorescreen
	jmp     cikis
Donboot:   
       mov      dx,64h
       mov      al,0FEh
       out      dx,al
       jmp      donboot 
yenibac:
       lea      dx,surucustr
       mov      ah,41h
       int      21h
       call     kopal
       jmp      cikis
restet:
       call     restorescreen
       call     part_boot_duzelt

kont_dosya_yarat proc near
	call    sesver
	call    menu1 
	jb      nomenu2n 
	cmp     surucu,2
	jb      nomenu2
	call    menu2
nomenu2:        
	print   7,3,14,msj3
nomenu2n:        
	jmp     cikis
menu1:         
       call     savescreen
       call     menupencere
       call     menu1yaz 
tekrarsor:       
       mov      ax,0c07h
       int      21h
       cmp      al,'e'
       jz       kopal
       cmp      al,'E'
       jz       kopal
       cmp      al,'h'
       jz       nokop
       cmp      al,'H'
       jz       nokop
       jmp      tekrarsor
nokop:  call    restorescreen
	stc
	ret
kopal:  call    restorescreen
	lea     dx,surucustr
	mov     ah,5bh
	mov     cx,2
	int     21h
	jnc     dosya_ok
	lea     dx,hata22
	call    yanlislik
	jmp     cikis
dosya_ok:        
	mov     kutukno,ax
	call    dosyaya_yaz
	ret
menu2:
	call     savescreen 
	call     menupencere
	call     menu2yaz 
tekrarsor1:       
	mov      ax,0c07h
	int      21h
	cmp      al,'e'
	jz       kopal1
	cmp      al,'E'
	jz       kopal1
	cmp      al,'h'
	jz       nokop1
	cmp      al,'H'
	jz       nokop1
	jmp      tekrarsor1
nokop1: call     restorescreen
	ret
kopal1: call     restorescreen
	mov      surucustr,'A'
	lea      dx,surucustr
	mov      ah,5bh
	mov      cx,2
	int      21h
	jnc      dosya_ok1
	lea      dx,hata22 
	call     yanlislik
	jmp      cikis 
dosya_ok1:        
	mov      kutukno,ax
	call     dosyaya_yaz
	ret
menu1yaz:
       print    9,17,4fh,men1s1
       print    10,18,4fh,men1s2
       print    11,18,4fh,men1s3
       print    13,30,74h,evete
       print    13,31,4fh,evetd
       print    13,46,74h,hayirh
       print    13,47,4fh,hayird
       ret

menu2yaz:
       print    9,16,4fh,diskop1
       print    10,16,4fh,diskop2
       print    13,30,74h,evete
       print    13,31,4fh,evetd
       print    13,46,74h,hayirh
       print    13,47,4fh,hayird
       ret

menupencere:
       window   8,15,50,5,4fh,1
       ret
kont_dosya_yarat endp


dosyaya_yaz     proc near
	mov     bx,kutukno
	lea     dx,part
	mov     cx,1024
	mov     ah,40h
	int     21h
	jnc     yaz_ok 
	call    silbit
	lea     dx,hata23
	call    yanlislik
	jmp     cikis
yaz_ok:        
	cmp     ax,cx
	jz      yazmatam
	lea     dx,hata24
	call    yanlislik
silicik:        
	call    silbit
	jmp     cikis
yazmatam:
	mov     ah,3eh
	int     21h
	ret
silbit:       
	mov     ah,3eh
	int     21h
	lea      dx,surucustr
	mov      ah,41h
	int      21h
	ret

dosyaya_yaz endp


dosyayi_guncelle proc near
	call    dosyaya_yaz
	print   7,3,14,msj3
	jmp     cikis
dosyayi_guncelle endp


part_boot_duzelt proc near
	cmp     surucu,80h
	jb      disketeyaz
	mov     ax,0301h
	mov     cx,1
	mov     dh,1
	mov     dl,surucu
	lea     bx,tampon2      ;boot
	int     13h
	jnc     disketeyaz
	lea     dx,hata25
	call    yanlislik
	jmp     cikis 
disketeyaz:        
	mov     ax,0301h
	mov     cx,1
	mov     dh,0
	mov     dl,surucu
	lea     bx,tampon1      ;part
	int     13h
	jnc     bootayazildi
	lea     dx,hata26
	call    yanlislik
	jmp     cikis 
bootayazildi:
	print   7,3,14,msj7        
	jmp     cikis
part_boot_duzelt endp



part_boot_oku proc near
	mov     si,3
tekrarpartoku:
	mov     ax,0201h
	mov     cx,1
	mov     dh,00
	mov     dl,surucu
	lea     bx,part
	int     13h
	jb      okuhata
	jmp     bootoku
okuhata:
	xor     ax,ax
	int     13h
	dec     si
	jnz     tekrarpartoku
	lea     dx,hata27
	call    yanlislik
	jmp     cikis 
bootoku:
	mov     si,3
tekrarbootoku:
	mov     ax,0201h
	mov     cx,1
	mov     dh,0
	cmp     surucu,80h
	jb      diskettir
	mov     dh,1
diskettir:
	mov     dl,surucu
	lea     bx,boot
	int     13h         
	jb      okumahata
	jmp     okumabitti
okumahata:
	xor     ax,ax
	int     13h 
	dec     si
	jnz     tekrarbootoku
	lea     dx,hata28
	call    yanlislik
	jmp     cikis
okumabitti:
	ret
part_boot_oku endp

cikis:
	mov     ah,0eh
	mov     dl,eskisurucu
	int     21h
	call    cursor
	mov     ax,1114h
	xor     bx,bx
	int     10h
	mov     ah,0fh
	int     10h
	xor     ah,ah
	int     10h
	mov     ah,2
	mov     dx,23*256
	mov     bh,0
	int     10h
	call    set_old_int24h
	Mov     Ah,4ch
	Int     21h
bootkoru endp




sormenu1 proc near
	push    bx dx 
	call    sesver
	call    savescreen
	window  9,15,50,5,4fh,1
	pop     dx
	call    ekryaz  pascal,10,35,4eh,dx
	print   11,29,4fh,menu1str
	print   13,21,4fh,secimstr
	print   13,21,74h,aktift
	print   13,34,74h,aktifd
	print   13,45,74h,aktifc
	print   13,57,74h,aktifb
tekrarsec1:
	mov     ax,0c07h
	int     21h
	and     al,11011111b
	cmp     al,'B'
	jnz     sec11
	jmp     donboot        
sec11:        
	cmp     al,'C'
	jnz     sec21
	pop bx
	pop ax
	stc
	ret
sec21:
	cmp     al,'D'
	jnz     sec31
	call    restorescreen
	pop     bx
	stc
	ret
sec31:  cmp     al,'T'
	jnz     tekrarsec1
	call    restorescreen
	pop     bx
	clc
	ret
sormenu1        endp


antiboot proc near
	call    arananboot        
	mov     al,searchdrive
	cmp     al,2
	jb      extwwno
	mov     al,80h
extwwno:
	mov     surucu,al
	call    part_boot_oku        
	lea     di,part
	lea     si,stonedduz
	call    imzayabak
	jb      bootyok1
	lea     si,part
	cmp     word ptr ds:[si],5eah
	jnz     bootyok1
	inc     bootbsayi
	call    bulunanboot
	lea     dx,stonedmsj
	call    sormenu1
	jb      bootyok1
	call    temizle1
bootyok1:
	lea     di,part
	lea     si,nointduz
	call    imzayabak
	jb      bootyok2
	lea     si,part
	cmp     word ptr ds:[si],3cebh
	jnz     bootyok2
	inc     bootbsayi
	call    bulunanboot
	lea     dx,nointmsj
	call    sormenu1
	jb      bootyok2
	call    temizle1
bootyok2:
	lea     di,part
	lea     si,michduz
	call    imzayabak
	jb      bootyok3
	lea     si,part
	cmp     word ptr ds:[si],0ace9h
	jnz     bootyok3
	inc     bootbsayi
	call    bulunanboot
	lea     dx,michmsj
	call    sormenu1
	jb      bootyok3
	call    temizle1
bootyok3:
	lea     di,part
	cmp     word ptr ds:[di],34ebh
	jnz     cany
	cmp     word ptr ds:[di+36h],0c031h
	jnz     cany
	cmp     word ptr ds:[di+36h+11],0e430h
	jnz     cany
	cmp     word ptr ds:[di+36h+11+2],13cdh
	jnz     cany
	cmp     word ptr ds:[di+36h+11+2+2],0fa72h
	jnz     cany
	cmp     word ptr ds:[di+36h+11+2+2+2+12],13cdh
	jnz     cany
	cmp     word ptr ds:[di+36h+11+2+2+2+12+2],0ea72h
	jnz     cany
	inc     bootbsayi
	call    bulunanboot
	lea     dx,cansumsj
	call    sormenu1
	jb      cany
	call    temizle2
cany:
	lea     di,boot
	lea     si,formdduz
	call    imzayabak
	jb      bootyok5
	lea     si,boot
	cmp     word ptr ds:[si],53ebh
	jnz     bootyok5
	inc     bootbsayi
	call    bulunanboot
	lea     dx,formmsj
	call    sormenu1
	jb      bootyok5
	call    temizle3
bootyok5:
	lea     di,boot
	lea     si,acadbootduz
	call    imzayabak
	jb      acadyok
	lea     si,boot
	cmp     word ptr ds:[si],9ce9h
	jnz     acadyok
	cmp     word ptr ds:[si+1],009ch
	jnz     acadyok
	inc     bootbsayi
	call    bulunanboot
	lea     dx,anticadbootmsj
	call    sormenu1
	jb      acadyok
	call    temizle4
acadyok:        
	clc
	ret

temizle1:
	push    ax bx cx dx di si
	mov     si,3
tekraroku:
	mov     ax,0201h
	mov     cx,3
	mov     dh,1
	mov     dl,surucu
	cmp     dl,80h
	jnz     flopyy
	mov     cx,7
	mov     dh,0
flopyy:
	lea     bx,tampon1
	int     13h
	jnc     okumatamam
	xor     ax,ax
	int     13h
	dec     si
	jnz     basarisiz
	jmp     tekraroku
okumatamam:
	mov     ax,0301h
	mov     cx,1
	mov     dh,0
	mov     dl,surucu
	lea     bx,tampon1
	int     13h
	jb      basarisiz
	inc     temizbsayi
	call    temizboot
	pop     si di dx cx bx ax
	ret
basarisiz:
	stc
	pop     si di dx cx bx ax
	ret


temizle2:
	push    ax bx cx dx di si
	mov     di,5
	lea     si,part+36h+17
agaara:        
	cmp     byte ptr ds:[si],0b9h
	jnz     bg1
	mov     cx,word ptr ds:[si+1]
bg1:        
	cmp     byte ptr ds:[si],0bah 
	jnz     bg2
	mov     dx,word ptr ds:[si+1]
bg2:
	add     si,3
	dec     di
	jnz     agaara
	mov     si,3
tekrarokucan:
	mov     bx,offset tampon1
	mov     ax,0201h
	int     13h
	jnc     okumatamamcan
	xor     ax,ax
	int     13h
	dec     si
	jnz     basarisizcan
	jmp     tekrarokucan
basarisizcan:
	jmp     cancik
okumatamamcan:        
	cmp     word ptr ds:[tampon1],65ebh
	jnz     basarisizcan
	mov     ax,word ptr ds:[tampon1+6]
	mov     word ptr ds:[part],ax
	lea     si,tampon1+8
	lea     di,part+36h
	mov     cx,19
	cld
	rep     movsw
	mov     ax,0301h
	lea     bx,part
	mov     cx,1
	xor     dh,dh
	mov     dl,surucu
	int     13h
cancik: 
	pop     si di dx cx bx ax
	ret
temizle3:
	push    ax bx cx dx di si
	mov     si,5
tekrarokufo:
	mov     ax,0201h
	mov     cx,word ptr ds:[boot+49h]
	mov     dx,word ptr ds:[boot+4bh]
	lea     bx,tampon1
	int     13h
	jnc     okumatamamfo
	xor     ax,ax
	int     13h
	dec     si
	jnz     basarisizfo
	jmp     tekrarokufo
okumatamamfo:
	mov     ax,0301h
	mov     dl,surucu
	mov     dh,0
	cmp     dl,80h
	jnz     fll1e
	mov     dh,1
fll1e:        
	mov     cx,1
	lea     bx,tampon1
	int     13h
	jb      basarisizfo
	inc     temizbsayi
	call    temizboot
	pop     si di dx cx bx ax
	ret
basarisizfo:
	stc
	pop     si di dx cx bx ax
	ret

imzayabak: 
	mov     cx,512
	cld
donguboot:
	mov     al,byte ptr ds:[si]
	cmp     byte ptr es:[di],al
	jz      buldu
	inc     di
budegilmis:
	loop    donguboot
	stc 
	ret

buldu:
	push    si di cx
	mov     cx,19
	cld
	rep     cmpsb
	jz      tamam 
	pop     cx di si
	inc     di
	jmp     budegilmis
tamam:
	pop     cx di si
	clc
	ret


imzayabak1: 
	mov     cx,512
	cld
donguboot1:
	mov     al,byte ptr ds:[si]
	cmp     byte ptr es:[di],al
	jz      buldu1
	inc     di
budegilmis1:
	loop    donguboot1
	stc 
	ret

buldu1:
	push    si di cx
	mov     cx,15
	cld
	rep     cmpsb
	jz      tamam1 
	pop     cx di si
	inc     di
	jmp     budegilmis1
tamam1:
	pop     cx di si
	clc
	ret


temizle4:
	push    ax bx cx dx di si
	mov     si,5
tekrarokucad:
	mov     ax,0201h
	mov     cx,word ptr ds:[boot+43h]
	mov     dx,word ptr ds:[boot+45h]
	add     cx,8
	lea     bx,tampon1
	int     13h
	jnc     okumatamamcad
	xor     ax,ax
	int     13h
	dec     si
	jnz     basarisizcad
	jmp     tekrarokucad
okumatamamcad:
	cmp     word ptr ds:[tampon1],9ce9h
	jnz     basarisizcad
	mov     ax,0301h
	mov     dl,surucu
	mov     dh,0
	cmp     dl,80h
	jnz     fll1
	mov     dh,1
fll1:        
	mov     cx,1
	lea     bx,tampon1
	int     13h
	jb      basarisizcad
	inc     temizbsayi
	call    temizboot
	pop     si di dx cx bx ax
	ret
basarisizcad:
	stc
	pop     si di dx cx bx ax
	ret

antiboot endp
end

