Program 3D; { Ahmet zkesek, stanbul niversitesi }

uses crt, graph;

var
  gm, gd, xp, yp, zp,
  ofs1, ofs2, koo1, koo2,
  xofs, yofs, zofs, rot        :integer;
  przm, przmxy, przmxz, przmyz :array[1..8,1..3] of integer;
  tus                          :char;
  cisim1, cisim2, cisim3       :pointer;
  cikis                        :boolean;

procedure init;
begin
   przm[1,1]:=50;  przm[1,2]:=50;  przm[1,3]:=50;
   przm[2,1]:=150; przm[2,2]:=50;  przm[2,3]:=50;
   przm[3,1]:=150; przm[3,2]:=150; przm[3,3]:=50;
   przm[4,1]:=50;  przm[4,2]:=150; przm[4,3]:=50;
   przm[5,1]:=50;  przm[5,2]:=50;  przm[5,3]:=150;
   przm[6,1]:=150; przm[6,2]:=50;  przm[6,3]:=150;
   przm[7,1]:=150; przm[7,2]:=150; przm[7,3]:=150;
   przm[8,1]:=50;  przm[8,2]:=150; przm[8,3]:=150;

   xp:=15;
   yp:=15;
   zp:=-50;
   xofs:=100;
   yofs:=100;
   zofs:=100;
end;

procedure scale(var x, y:integer; tx, ty:integer; sx, sy:real);
begin
   x:=trunc((x*sx)+tx);
   y:=trunc((y*sy)+ty);
end;

procedure parelel(var x, y:integer; z:integer);
begin
   x:=round(x-xp*z/zp);
   y:=round(y-yp*z/zp);
end;

procedure perspektif(var x, y:integer; z:integer);
begin
   x:=round(xp-zp*(x-xp)/(z-zp));
   y:=round(yp-zp*(y-yp)/(z-zp));
end;

procedure rotate(q, xo, yo:integer;var xs, ys:integer);
var
 x, y:integer;
begin
 x:=xs-xo;
 y:=ys-yo;
 xs:=round(x*cos(q*pi/180)+y*sin(q*pi/180));
 ys:=round(y*cos(q*pi/180)-x*sin(q*pi/180));
 xs:=xs+xo;
 ys:=ys+yo;
end;

procedure tasixy;
var i:integer;
begin
   for i:=1 to 8 do begin
       przmxy[i, 1]:=przm[i, 1];
       przmxy[i, 2]:=przm[i, 2];
       przmxy[i, 3]:=przm[i, 3];
       end;
end;

procedure tasixz;
var i:integer;
begin
   for i:=1 to 8 do begin
       przmxz[i, 1]:=przm[i, 1];
       przmxz[i, 2]:=przm[i, 2];
       przmxz[i, 3]:=przm[i, 3];
       end;
end;

procedure tasiyz;
var i:integer;
begin
   for i:=1 to 8 do begin
       przmyz[i, 1]:=przm[i, 1];
       przmyz[i, 2]:=przm[i, 2];
       przmyz[i, 3]:=przm[i, 3];
       end;
end;

procedure ciz;
var i, j:integer;
begin
   for i:=1 to 8 do begin
       j:=i+1;
       if i = 4 then j:=1;
       if i = 8 then j:=5;
       line(przmxy[i, 1], przmxy[i, 2], przmxy[j, 1], przmxy[j, 2]);
       line(przmxz[i, 1], przmxz[i, 3], przmxz[j, 1], przmxz[j, 3]);
       line(przmyz[i, 3], przmyz[i, 2], przmyz[j, 3], przmyz[j, 2]);
       end;
   for i:=1 to 4 do begin
       if i = 4 then j:=8 else j:=i+4;
       line(przmxy[i, 1], przmxy[i, 2], przmxy[j, 1], przmxy[j, 2]);
       line(przmxz[i, 1], przmxz[i, 3], przmxz[j, 1], przmxz[j, 3]);
       line(przmyz[i, 3], przmyz[i, 2], przmyz[j, 3], przmyz[j, 2]);
       end;
end;

procedure prizma;
var
   i, alfa:integer;
begin
   alfa:=1;
   init;
   case rot of
      1 : begin ofs1:=yofs; ofs2:=zofs; koo1:=2; koo2:=3; end;
      2 : begin ofs1:=xofs; ofs2:=zofs; koo1:=1; koo2:=3; end;
      3 : begin ofs1:=xofs; ofs2:=yofs; koo1:=1; koo2:=2; end;
      end;
   repeat
      setactivepage(1);
      clearviewport;
      for i:=1 to 8 do begin
          rotate(alfa, ofs1, ofs2, przm[i, koo1], przm[i, koo2]);
          parelel(przm[i,1], przm[i,2], przm[i,3]);
          scale(przm[i,1], przm[i,2], -20, 190, 0.50, 0.50);
          end;
      tasixy;
      init;
      for i:=1 to 8 do begin
          rotate(alfa, ofs1, ofs2, przm[i, koo1], przm[i, koo2]);
          parelel(przm[i,1], przm[i,3], przm[i,2]);
          scale(przm[i,1], przm[i,3], 130, 190, 0.52, 0.52);
          end;
      tasixz;
      init;
      for i:=1 to 8 do begin
          rotate(alfa, ofs1, ofs2, przm[i, koo1], przm[i, koo2]);
          parelel(przm[i,2], przm[i,3], przm[i,1]);
          scale(przm[i,2], przm[i,3], 190, 290, 0.50, 0.50);
          end;
      tasiyz;
      init;
      setcolor(10);
      ciz;
      for i:=1 to 8 do begin
          rotate(alfa, ofs1, ofs2, przm[i, koo1], przm[i, koo2]);
          perspektif(przm[i,1], przm[i,2], przm[i,3]);
          scale(przm[i,1], przm[i,2], -10, 125, 1, 1);
          end;
      tasixy;
      init;
      for i:=1 to 8 do begin
          rotate(alfa, ofs1, ofs2, przm[i, koo1], przm[i, koo2]);
          perspektif(przm[i,1], przm[i,3], przm[i,2]);
          scale(przm[i,1], przm[i,3], 145, 125, 1, 1);
          end;
      tasixz;
      init;
      for i:=1 to 8 do begin
          rotate(alfa, ofs1, ofs2, przm[i, koo1], przm[i, koo2]);
          perspektif(przm[i,2], przm[i,3], przm[i,1]);
          scale(przm[i,2], przm[i,3], 125, 300, 1, 1);
          end;
      tasiyz;
      init;
      setcolor(11);
      ciz;
      getimage(0,   100, 100, 300, cisim1^);
      getimage(150, 100, 250, 300, cisim2^);
      getimage(300, 100, 400, 300, cisim3^);
      setactivepage(0);
      putimage(0,   100, cisim1^, 0);
      putimage(150, 100, cisim2^, 0);
      putimage(300, 100, cisim3^, 0);
      inc(alfa, 3);
      alfa:=alfa mod 360;
   until keypressed;
end;



begin
   cikis:=false;
   detectgraph(gd, gm);
   initgraph(gd, gm, '');
   if graphresult <> grok then halt(1);
   setvisualpage(0);
   setactivepage(0);
   outtextxy(150, getmaxy-20, 'COMPUTER GRAPHICS');
   setcolor(12);
   outtextxy(5,   getmaxy-80, 'DUZLEM XY');
   outtextxy(175, getmaxy-80, 'DUZLEM XZ');
   outtextxy(325, getmaxy-80, 'DUZLEM ZY');
   setcolor(13);
   line(5,   getmaxy-150, 50,  getmaxy-150);
   line(175, getmaxy-150, 225, getmaxy-150);
   line(325, getmaxy-150, 370, getmaxy-150);
   outtextxy(55,  getmaxy-155, 'X');
   outtextxy(235, getmaxy-155, 'X');
   outtextxy(375, getmaxy-155, 'Z');
   line(5,   getmaxy-150, 30,  getmaxy-130);
   line(175, getmaxy-150, 200, getmaxy-130);
   line(325, getmaxy-150, 350, getmaxy-130);
   outtextxy(35,  getmaxy-125, '-Z');
   outtextxy(200, getmaxy-125, '-Y');
   outtextxy(350, getmaxy-125, '-X');
   line(5,   getmaxy-150, 5,   getmaxy-110);
   line(175, getmaxy-150, 175, getmaxy-110);
   line(325, getmaxy-150, 325, getmaxy-110);
   outtextxy(5,   getmaxy-105, 'Y');
   outtextxy(175, getmaxy-105, 'Z');
   outtextxy(325, getmaxy-105, 'Y');
   setcolor(14);
   outtextxy(5,   getmaxy-50, 'X - Rotate x;');
   outtextxy(125, getmaxy-50, 'Y - Rotate y;');
   outtextxy(245, getmaxy-50, 'Z - Rotate z;');
   outtextxy(365, getmaxy-50, 'Q - Cikis;');
   rot:=1;
   getmem(cisim1, imagesize(0,   100, 100, 300));
   getmem(cisim2, imagesize(150, 100, 250, 300));
   getmem(cisim3, imagesize(300, 100, 400, 300));
   repeat
      case tus of
           'x', 'X': rot:=1;
           'y', 'Y': rot:=2;
           'z', 'Z': rot:=3;
           'q', 'Q': cikis:=true;
           end;
      prizma;
      tus := readkey;
   until cikis=false;
   closegraph;
end.